// ZbiorLiter.cpp: implementation of the CZbiorLiter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "scrab.h"
#include "ZbiorLiter.h"
#include "time.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CZbiorLiter::~CZbiorLiter()
{
	znak* n=first;
	while(n)	
	{
		znak* next=n->next;
		delete n;
		n=next;
	}

}

void CZbiorLiter::dodaj(char a)
{
	znak* nowy = new znak(a);
	nowy->next=first;
	first=nowy;
}

void CZbiorLiter::usun(char a)
{
	znak* prev=NULL;
	znak* n=first;
	while(n)
	{
		if(n->wart==a)
		{
			if(prev) prev->next=n->next; 
			else first=n->next;
		delete n;
		return;
		}
		prev=n;
		n=n->next;
	}
}

int CZbiorLiter::jest(char a)
{
	znak* n=first;
	while(n)	
	{
		if(n->wart==a) return 1;
		n=n->next;

	}
	return 0;
}

char CZbiorLiter::losuj()
{
time_t czasSekundy;

czasSekundy=time(NULL);

	srand(czasSekundy);
	int a=ile(), b;
	char c;
	if (a==0) 
		return(NULL);
	else
	{
		b=rand()%a;
		a=0;

		znak* prev=NULL;
		znak* n=first;
		while(a!=b)	
		{
			prev=n;
			a++;
			n=n->next;
		}
		
		c=n->wart;
		if(prev) prev->next=n->next; 
		else first=n->next;

		delete n;
		return(c);
	}
}

int CZbiorLiter::ile()
{
	int m=0;

	znak* n=first;
	while(n)	
	{
		znak* next=n->next;
		m++;
		n=next;
	}

	return(m);
}
